/* EXAMPLE 5.5.1 */
options ls=78  nodate nonumber;
FILENAME PS '~/multivar/psych.dat';
DATA test;
  INFILE PS;
  INPUT Sex Test1 Test2 Test3 Test4;
TITLE 'EXAMPLE 5.5.1';
PROC IML;
  USE test;
  READ ALL VAR {Test1 Test2 Test3 Test4} INTO X1 where (sex=1);
  READ ALL VAR {Test1 Test2 Test3 Test4} INTO X2 where (sex=2);
  N1 = NROW(X1);
  N2 = NROW(X2);
  yBAR1 = 1/N1*X1`*J(N1,1);
  yBAR2 = 1/N2*X2`*J(N2,1);
  S1 = 1/(N1-1)*X1`*(I(N1)-1/N1*J(N1))*X1;     /* W1 = X1`*(I(N1)-1/N1*J(N1))*X1 */
  S2 = 1/(N2-1)*X2`*(I(N2)-1/N2*J(N2))*X2;     /* W2 = X2`*(I(N2)-1/N2*J(N2))*X2 */
  Spl = (1/(N1+N2-2))*((N1-1)*S1+(N2-1)*S2);     /* Spl = 1/(N1+N2-2)*(W1+W2)      */
  T2 = N1*N2/(N1+N2)*(yBAR1-yBAR2)`*INV(Spl)*(yBAR1-yBAR2);

const=((n1+n2)/(n1*n2));
a=inv(spl)*(ybar1-ybar2);
t2a = ((a`*(ybar1-ybar2))**2)/(const*a`*spl*a);
a0={2,-1,2,-1};

t2a0 = ((a0`*(ybar1-ybar2))**2)/(const*a0`*spl*a0);

/* test to see if a is proportional to a0*/
ts=61*((t2a-t2a0)/(62+t2a0));

print a  t2 t2a t2a0 ts ;




quit;


ENDSAS;
