options ls=72;

data blood;
infile '~/multivar/probe.dat';  
input obs y1 y2 y3 y4 y5;

run;

proc princomp noprint outstat=cor;
 var y1 y2 y3 y4 y5;

run;
proc iml ;
use blood ;
read all var { y1 y2 y3 y4 y5} into x ;
use cor ;
read all var { y1 y2 y3 y4 y5} into r where (_TYPE_ = 'CORR');

  n = nrow(x);
  p = ncol(x);
  v=n-1;
dr=diag(r);
nrma=r-dr  ;

rbar=(1/(p*(p-1)))*(nrma[+,+]);
w=1-rbar;
q=((p-1)##2 *(1-w##2))/(p-(p-2)*w##2);
ssum=0;
totsum=0;
rowcnt=1;
do while (rowcnt <=p);
colcnt=1;
do while (colcnt <=p);
if rowcnt < colcnt then
do;
ssum=(r(|rowcnt,colcnt|)-rbar);
ssum=ssum##2;
totsum=ssum+totsum;
end;
colcnt=colcnt+1;
end;
rowcnt=rowcnt+1;
end;
vcnt=1;
vrbar=j(p,1);
do while(vcnt<=p);
sumr=sum(r[,vcnt])-1;
vrbar(|vcnt|)=(1/(p-1))*sumr;
vcnt=vcnt+1;
end;
vrbar=(vrbar-rbar);
vrbar=q*(vrbar`*vrbar);
u=(v/w##2)*(totsum-vrbar);
cvchi=cinv(.95,.5*(p+1)*(p-2));
cv=cinv(.05,.5*(p+1)*(p-2));
print u cvchi cv;
endsas;





