options ls=72;

/* input data - square it */

data new;
infile 'table1-1.dat';
input obs x y;
proc sql;
create table z as
select mean(x) as meanx, mean(y) as meany, x, y
from new;
quit;
run;

proc sql;
create table z1 as
select sum((x-meanx)*(y-meany)) as top, sum((x-meanx)**2) as sumx,
       sum((y-meany)**2) as sumy
from z;
quit;
run;

data z2;
set z1;
rxy = top/((sumx*sumy)**.5);
r_xy = rxy +  rxy*(1-rxy**2)/(2*(20-3));
proc print;
var rxy r_xy;
run;
