options ls=72;
 filename x 'table1-3.dat';
data z;
infile x;
input obs y1 y2 y3 y4 y5;
run;

proc iml;
use z;
read all var {y1 y2 y3 y4 y5} into y;
reset noprint;

ca = {1 -1 0 0 0,0 1 -1 0 0,0 0 1 -1 0,0 0 0 1 -1};
cb = {3 3 -2 -2 -2};                  
cc = {1 0 0 -1 0};
cd = {1 -1 0 0 0,0 0 1 -1 0};
n=nrow(y);
xbar = 1/n*y`*J(n,1);
s=1/(n-1)*y`*(I(n)-1/n*J(N))*y;

tsqa = n*(ca*xbar)`*inv(ca*s*ca`)*(ca*xbar);
tsqb = n*(cb*xbar)`*inv(cb*s*cb`)*(cb*xbar);
tsqc = n*(cc*xbar)`*inv(cc*s*cc`)*(cc*xbar);
tsqd = n*(cd*xbar)`*inv(cd*s*cd`)*(cd*xbar);

print 'Problem 35 part a',tsqa;
print 'Problem 35 part b', tsqb;
print 'Problem 35 part c', tsqc;
print 'Problem 35 part d', tsqd;
quit;
