/* problem 3.41 */


options ls=72;
FILENAME beet  'table3-8.dat';
DATA SCORES;
  INFILE beet; 
  INPUT obs group y1 y2 y3 y4;      
PROC IML;
  USE SCORES;
  read all var {y1 y2 y3 y4} into X1 where(group=1);
  read all var {y1 y2 y3 y4} into X2 where(group=2);
  RESET noPRINT;
  N1 = NROW(X1);
  N2 = NROW(X2);
  v = n1 + n2 - 2;
  x1BAR = 1/N1*X1`*J(N1,1);
  x2BAR = 1/N2*X2`*J(N2,1);
  
  S2 = 1/(N2-1)*X2`*(I(N2)-1/N2*J(N2))*X2;
  S1 = 1/(N1-1)*X1`*(I(N1)-1/N1*J(N1))*X1;
  Spl = 1/(N1+N2-2)*((N1-1)*(S1)+(N2-1)*(S2));
  Tsq = N1*N2/(N1+N2)*(X1BAR-X2BAR)`*INV(Spl)*(X1BAR-X2BAR);
 
print "Part a",  tsq;
/* *************************for part b *************************** */

a = inv(spl)*(x1bar-x2bar);
print "Part b", a;

***************************** for part d *****************************;

x1barno1 = x1bar[2:4,];      
x1barno2 = x1bar(|{1 3 4},|);
x1barno3 = x1bar(|{1 2 4},|);
x1barno4 = x1bar(|{1 2 3},|);


x2barno1 = x2bar[2:4,];
x2barno2 = x2bar(|{1 3 4},|);
x2barno3 = x2bar(|{1 2 4},|);
x2barno4 = x2bar(|{1 2 3},|);


sno1 = spl(|{2 3 4},{2 3 4}|);
sno2 = spl(|{1 3 4},{1 3 4}|);
sno3 = spl(|{1 2 4},{1 2 4}|);
sno4 = spl(|{1 2 3},{1 2 3}|);

  p=3; /* p + 1 = 4 */
  T1 = N1*N2/(N1+N2)*(X1BARno1-X2BARno1)`*INV(Sno1)*(X1BARno1-X2BARno1);
  T2 = N1*N2/(N1+N2)*(X1BARno2-X2BARno2)`*INV(Sno2)*(X1BARno2-X2BARno2);
  T3 = N1*N2/(N1+N2)*(X1BARno3-X2BARno3)`*INV(Sno3)*(X1BARno3-X2BARno3);
  T4 = N1*N2/(N1+N2)*(X1BARno4-X2BARno4)`*INV(Sno4)*(X1BARno4-X2BARno4);

tno1 = (v-p)*(tsq-t1)/(v+t1);
tno2 = (v-p)*(tsq-t2)/(v+t2);
tno3 = (v-p)*(tsq-t3)/(v+t3);
tno4 = (v-p)*(tsq-t4)/(v+t4);

print "Part d", tno1 tno2 tno3 tno4;

********************************* part e ******************************;

 x1bar12=x1bar[1:2];
 x2bar12=x2bar[1:2];

 s12 = spl[1:2,1:2];


 T12 = N1*N2/(N1+N2)*(X1BAR12-X2BAR12)`*INV(S12)*(X1BAR12-X2BAR12);


tadj12 = (v-2)*(tsq-t12)/(v+t12);

print "Part e", tadj12;


ENDSAS;
