options ls=80 nodate ;
data bug;
infile 'table3-8.dat';
  input id Group y1 y2 y3 y4;
run;
title 'prob 3.40';
Proc iml;
  use bug;
  read all var {y1 y2 y3 y4} into y;
  p=ncol(y);
  y1 = y[1:19,];
  y2 = y[20:39,];
  n1 = nrow(y1);
  n2 = nrow(y2);
  mult=(n1+n2)/(n1*n2);
  y1bar = 1/n1*y1`*j(n1,1);
  y2bar = 1/n2*y2`*j(n2,1);
  s1 = 1/(n1-1)*y1`*(i(n1)-1/n1*j(n1))*y1;     
  s2 = 1/(n2-1)*y2`*(i(n2)-1/n2*j(n2))*y2;     
  spl = 1/(n1+n2-2)*((n1-1)*s1+(n2-1)*s2);     
  a=inv(spL)*(y1bar-y2bar);
  t2= n1*n2/(n1+n2)*(y1bar-y2bar)`*a;
print t2;
***************************** part a test C(mu1-mu2)=0******;
c={-1 1 0 0 ,
    0 -1 1 0,
    0 0 -1 1};
ts=(inv(mult))*(y1bar-y2bar)`*c`*inv(c*spl*c`)*c*(y1bar-y2bar);

t2cv = Finv(.95,p-1,n1+n2-(p-1)-1) * (n1+n2-2)*(p-1)/(n1+n2-(p-1)-1);
print 'H0:C(mu1-mu2)=0';
print 'The Test Statistic and Hotelling`s critival value';
print ts t2cv;
*********************part b*********;
c2={1 -3 1 1,
1 0 0 -1};

ts2=(inv(mult))*(y1bar-y2bar)`*c2`*inv(c2*spl*c2`)*c2*(y1bar-y2bar);

t2cv2 = Finv(.95,2,n1+n2-(2)-1) * (n1+n2-2)*(2)/(n1+n2-(2)-1);
print 'part b';
print 'H0:C(mu1-mu2)=0';
print 'The Test Statistic and Hotelling`s critival value';
print ts2 t2cv2;
endsas;
