options ls=72;

data chem; 
infile 'tab4-11.dat';
input group y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2;



proc glm data=chem;
class group; 
model y1 - y11 = group; 
contrast '1,2 vs. 3,4'
 group -1 -1 1 1;
contrast '1 vs. 2'
 group 1 -1 0 0;
contrast '3 vs. 4'
 group 0 0 -1 1;
manova h=group/;
run;


proc glm data=chem;
class group;
model y6-y11 = group/nouni;
title 'Reduced model';
manova h=group;

endsas;


