options ls=78 nodate ;
DATA app;
  infile  'tab4-10.dat';
  input  treat block y1-y6 x1 x2;
run;

TITLE 'PROB 5.19';
PROC IML;
  USE app;
  READ ALL VAR {y1 y2 y3 y4 y5 y6} INTO x1 where (treat=1);
  READ ALL VAR {y1 y2 y3 y4 y5 y6} INTO x2 where (treat=2);

p=ncol(x1);
  n1 = nrow(X1);
  n2 = nrow(X2);
v=(n1+n2-2);
  X1BAR = 1/N1*X1`*J(N1,1);
  X2BAR = 1/N2*X2`*J(N2,1);
  S1 = 1/(N1-1)*X1`*(I(N1)-1/N1*J(N1))*X1;     
  S2 = 1/(N2-1)*X2`*(I(N2)-1/N2*J(N2))*X2;    
  Spl = 1/(v)*((N1-1)*S1+(N2-1)*S2);    
  a = INV(Spl)*(X1BAR-X2BAR);
d=diag(spl);
stda=(d##.5)*a;
 
  t1 = (X1BAR[1]-X2BAR[1])/SQRT(Spl[1,1]*(1/n1+1/n2));
  t2 = (X1BAR[2]-X2BAR[2])/SQRT(Spl[2,2]*(1/n1+1/n2));
  t3 = (X1BAR[3]-X2BAR[3])/SQRT(Spl[3,3]*(1/n1+1/n2));
  t4 = (X1BAR[4]-X2BAR[4])/SQRT(Spl[4,4]*(1/n1+1/n2));
  t5 = (X1BAR[5]-X2BAR[5])/SQRT(Spl[5,5]*(1/n1+1/n2));
  t6 = (X1BAR[6]-X2BAR[6])/SQRT(Spl[6,6]*(1/n1+1/n2));
htsqrd=((n1*n2)/(n1+n2))*(x1bar-x2bar)`*inv(spl)*(x1bar-x2bar);

Swo1=Spl[2:6,2:6];
Swo2=Spl(|{1 3 4 5 6},{1 3 4 5 6}|);
Swo3=Spl(|{1 2 4 5 6 },{1 2 4 5 6 }|);
Swo4=Spl(|{1 2 3 5 6},{1 2 3 5 6}|);
Swo5=Spl(|{1 2 3 4 6},{1 2 3 4 6}|);
Swo6=Spl(|{1 2 3 4 5 },{1 2 3 4 5}|);

x1wo1=x1bar(|{2 3 4 5 6},|);
x2wo1=x2bar(|{2 3 4 5 6},|);

x1wo2=x1bar(|{1 3 4 5 6},|);
x2wo2=x2bar(|{1 3 4 5 6},|);

x1wo3=x1bar(|{1 2 4 5 6},|);
x2wo3=x2bar(|{1 2 4 5 6},|);

x1wo4=x1bar(|{1 2 3 5 6},|);
x2wo4=x2bar(|{1 2 3 5 6},|);

x1wo5=x1bar(|{1 2 3 4 6},|);
x2wo5=x2bar(|{1 2 3 4 6},|);

x1wo6=x1bar(|{1 2 3 4 5},|);
x2wo6=x2bar(|{1 2 3 4 5},|);

  Two1 = n1*n2/(n1+n2)*(x1wo1-x2wo1)`*INV(Swo1)*(x1wo1-x2wo1);
  Two2 = n1*n2/(n1+n2)*(x1wo2-x2wo2)`*INV(Swo2)*(x1wo2-x2wo2);
  Two3 = n1*n2/(n1+n2)*(x1wo3-x2wo3)`*INV(Swo3)*(x1wo3-x2wo3);
  Two4 = n1*n2/(n1+n2)*(x1wo4-x2wo4)`*INV(Swo4)*(x1wo4-x2wo4);
  Two5 = n1*n2/(n1+n2)*(x1wo5-x2wo5)`*INV(Swo5)*(x1wo5-x2wo5);
  Two6 = n1*n2/(n1+n2)*(x1wo6-x2wo6)`*INV(Swo6)*(x1wo6-x2wo6);


parf1=(v-p+1)*(htsqrd-Two1)/(v+Two1);
parf2=(v-p+1)*(htsqrd-Two2)/(v+Two2);
parf3=(v-p+1)*(htsqrd-Two3)/(v+Two3);
parf4=(v-p+1)*(htsqrd-Two4)/(v+Two4);
parf5=(v-p+1)*(htsqrd-Two5)/(v+Two5);
parf6=(v-p+1)*(htsqrd-Two6)/(v+Two6);

print  a stda , t1 t2 t3 t4  t5 t6 ,  parf1 parf2 parf3 parf4 parf5 parf6;
endsas;
