options ls=72;

data soil;

infile 'tab4-11.dat';
input group y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 x1 x2;
************* to find quadratic classification functions *****;
proc iml;
use soil;
reset noprint;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into y1 where(group=1);
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into y2 where(group=2);
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into y3 where(group=3);
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into y4 where(group=4);
n1 = nrow(y1);
n2 = nrow(y2);
n3 = nrow(y3);
n4 = nrow(y4);


ybar1 = 1/n1*y1`*J(n1,1);
ybar2 = 1/n2*y2`*J(n2,1);
ybar3 = 1/n3*y3`*J(n3,1);
ybar4 = 1/n4*y4`*J(n4,1);

s1 = 1/(n1-1)*y1`*(I(n1) - 1/n1*J(n1))*y1;
s2 = 1/(n2-1)*y2`*(I(n2) - 1/n2*J(n2))*y2;
s3 = 1/(n3-1)*y3`*(I(n3) - 1/n3*J(n3))*y3;
s4 = 1/(n4-1)*y4`*(I(n4) - 1/n4*J(n4))*y4;

invs1 = det(s1);
invs2 = det(s2);
invs3 = det(s3);
invs4 = det(s4);
print invs1 invs2 invs3 invs4;
quit;
proc discrim data = soil outstat=ftstat
                method=normal pool=yes;
class group;
var y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11;
title 'Classification Analysis of Biochem data - part a and b';

proc discrim data = soil outstat=ftstat
                method=normal pool=no crossvalidate;
class group;
var y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11;
run;
**************6.18c sas code*********;
proc discrim data = soil outstat=ftstat
                method=normal pool=yes crossvalidate;
class group;
var y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11;
title 'Classification Analysis of Biochem data - part c and d using holdout';
run;


