options ls=72;
FILENAME bioch 'tab4-11.dat';
DATA bio;
  INFILE bioch;
  INPUT group y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11 X1 X2;
run;


*************** parts a and b ************************;
PROC REG  data=bio;
  MODEL y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11= X1 X2;
title 'OVERALL part a, partial1&2 part b ,CB & CBM  part c & part d ';
  OVERALL:  MTEST ;
  partial1: mtest x1 ;
  partial2: mtest x2 ;
  CB: mtest x1-x2=0 ;
  CBM: mtest 2*y1+2*y2-y8-y9-y10-y11=0  ;
run;
******CB and CBM are parts c and d.************;

*************** parts c and d ************************;
/*PROC REG  data=bio;
  model y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11= X1 X2 ;
  CB: mtest x1-x2=0 ;
  CBM: mtest 2*y1+2*y2-y8-y9-y10-y11=0  ;
run;*/
*************The commented out REG commands do the same as the following iml commands
****;
proc iml;  
use bio;
read all var {y1 y2 y3 y4 y5 y6 y7 y8 y9 y10 y11} into y;
read all var {x1 x2} into xa;
n = nrow(xa);

t = J(n,1);

x =t||xa; 

bhat = inv(x`*x)*x`*y;
c = {0 1 -1}; /* this compares each B2i with each B3i */

h = (c*bhat)`*inv(c*inv(x`*x)*c`)*c*bhat;
e = y`*y -bhat`*x`*y;

lambda = det(e)/det(e+h);
print 'Iml gets the same as Proc REG with in round off error';
print 'part c',lambda;
m={2,2,0,0,0,0,0,-1,-1,-1,-1};
em=m`*e*m;
hm=m`*h*m;
lam=det(m`*e*m)/det(m`*(e+h)*m);
lam2=det(em)/det(em+hm);
print  'part d' ,lam ;
ENDSAS;
