options ls=80 nodate ;
data gluc;
infile 'table1-4.dat';
  input  y1 y2 y3 x1 x2 x3;
run;
title ' 8.29 ';
proc cancorr 
  wprefix = fasting wname = 'fasting variables'
  vprefix = intake  vname = 'intake variables'  vdep wreg wdep vreg all outstat=temp;
  with y1 y2 y3;
  var x1 x2 x3 ;
run;
title 'Prob 8.26 leave out y1';
proc cancorr 
  wprefix = fasting wname = 'fasting variables'
  vprefix = intake  vname = 'intake variables' ;
  with  y2 y3;
  var x1 x2 x3 ;
run;

title 'Prob 8.26 leave out x1';
proc cancorr 
  wprefix = fasting wname = 'fasting variables'
  vprefix = intake  vname = 'intake variables' ;
  with y1 y2 y3;
  var  x2 x3 ;
run;

data prop;
set  temp;
if _TYPE_ = 'RAWSCORE'  ;
run;
proc iml ;
use prop;
read all var{x1 x2 x3} into b where(_NAME_='INTAKE1');
read all var{y1 y2 y3} into a where(_NAME_='FASTING1');
use gluc ;
read all var{x1 x2 x3} into x;
read all var{y1 y2 y3} into y;

u=a*y`;
v=b*x`;
up=u`;
vp =v`;
uv= up||vp;
create canvar from uv ;
append from uv;
data can;
merge gluc canvar;
u=col1 ;
v= col2;
run;
title 'Property 5';
proc reg;
model u=x1 x2 x3  ;
model v=y1 y2 y3;
run;
endsas;
