options ls=80 nodate ;
data rain;
infile 'table7-1.dat';
  input  y1 y2 y3 x1 x2 x3 x4 x5 x6;
run;
title ' 8.33 ';
proc cancorr 
  wprefix = y  wname = 'Y variables'
  vprefix = x  vname = 'X variables'  vdep wreg wdep vreg all outstat=temp ;
  with y1 y2 y3;
  var x1 x2 x3 x4 x5 x6;
run;
title 'Prob 8.26 leave out y1';
proc cancorr 
  wprefix = y  wname = 'Y variables'
  vprefix = x  vname = 'X variables'  vdep wreg wdep vreg all ;
  with  y2 y3;
  var x1 x2 x3 x4 x5 x6;
run;

title 'Prob 8.26 leave out x1';
proc cancorr 
  wprefix = y  wname = 'Y variables'
  vprefix = x  vname = 'X variables'  vdep wreg wdep vreg all ;
  with y1 y2 y3;
  var  x2 x3 x4 x5 x6;
run;

data prop;
set  temp;
if _TYPE_ = 'RAWSCORE'  ;
run;
proc iml ;
use prop;
read all var{x1 x2 x3 x4 x5 x6} into b where(_NAME_='X1');
read all var{y1 y2 y3} into a where(_NAME_='Y1');
use rain ;
read all var{x1 x2 x3 x4 x5 x6} into x;
read all var{y1 y2 y3} into y;

u=a*y`;
v=b*x`;
up=u`;
vp =v`;
uv= up||vp;
create canvar from uv ;
append from uv;
data can;
merge rain canvar;
u=col1 ;
v= col2;
run;
title 'Property 5';
proc reg;
model u=x1 x2 x3 x4 x5 x6  ;
model v=y1 y2 y3;
run;
endsas;
