options ls=78 nodate ;
DATA  son;
  INFILE '~/multivar/sons.dat';
  INPUT y1 y2 x1 x2 ;
proc iml;
use son;
read all var{y1 y2} into y;
read all var{x1 x2} into x;
  RESET PRINT;
d=y-x;
  n = NROW(d);
  p = Ncol(d);
sumd1=sum(d[1:n,1:1]);
sumd2=sum(d[1:n,2:2]);

  dbar = (1/n)*d`*J(n,1);
  Sd = 1/(n-1)*d`*(I(n)-1/n*J(n))*d; 
T2=n*dbar`*inv(Sd)*dbar;
lamcoef=t2;
v2=n-p;
power=1-probf(finv(.95,p,v2),p,v2,lamcoef);
print  power;

ENDSAS;

