options ls=72 nodate nonumber;
data new;
infile '~/multivar/rabbit.dat';
input y1 y2 group;
run;

proc glm outstat=er ;
class group;
model y1-y2  = group ;
contrast  '1vs2,3,4' group 3 -1 -1 -1;
contrast  '2,3vs4' group 0 -1 -1  2;
contrast  '2vs3' group 0 1 -1  0;

contrast  'w1vs2,3,4' group 14 -7 -5 -2;
contrast  'w2,3vs4' group 0 -7 -5  12;
contrast  'w2vs3' group 0 1 -1  0;
manova h=_all_/ printe printh;
run;

endsas;
