options ls=72;
FILENAME bioch '~/multivar/hematol.dat';
DATA bio;
  INFILE bioch;
  INPUT  y1 y2 y3 y4 y5 y6 ;
run;

/* The proc reg statments produce the overall R squared and the 
reduced R squareds*/
proc reg  data=bio;
  model  y4 =y1 y2 y3 y5 y6 ;
run;
proc reg  data=bio;
  model  y4 = y2 y3 y5 y6 ;
run;
proc reg  data=bio;
  model  y4 =y1  y3 y5 y6 ;
run;
proc reg  data=bio;
  model  y4 =y1 y2  y5 y6 ;
run;
proc reg  data=bio;
  model  y4 =y1 y2 y3  y6 ;
run;
proc reg  data=bio;
  model  y4 =y1 y2 y3 y5  ;
run;
proc iml;
/* see equation 7.63 in text*/
/* n=51,q=5,h=1, the top number in all the F s is the difference between the 
R squareds i.e .0007 in f1*/
r2=.9232;
opp=1-r2;
bot=opp/45;
f1=.0007/bot;
f2=.0022/bot;
f3=.8682/bot;
f4=.2995/bot;
f5=.0001/bot;

pv1=1-probf(f1,1,45);
pv2=1-probf(f2,1,45);
pv3=1-probf(f3,1,45);
pv4=1-probf(f4,1,45);
pv5=1-probf(f5,1,45);
 print '.0007' pv1;
 print '.0022' pv2;
 print '.8682' pv3;
 print '.2995' pv4;
 print '.0001' pv5;
quit;
endsas;
