options ls=80 nodate ;
data bug;
infile 'table3-8.dat';
  input id Group y1 y2 y3 y4;
run;
title 'prob 3.49';
proc rank data=bug out=rbug;
var y1 y2 y3 y4;
ranks ry1 ry2 ry3 ry4 ;
run;

Proc iml;
  use rbug;
  read all var {ry1 ry2 ry3 ry4} into ry1 where(group=1);
  read all var {ry1 ry2 ry3 ry4} into ry2 where(group=2);
  p=ncol(ry1);
  n1 = nrow(ry1);
  n2 = nrow(ry2);
  mult=(n1+n2)/(n1*n2);

  ry1bar = 1/n1*ry1`*j(n1,1);
  ry2bar = 1/n2*ry2`*j(n2,1);
  s1 = 1/(n1-1)*ry1`*(i(n1)-1/n1*j(n1))*ry1;     
  s2 = 1/(n2-1)*ry2`*(i(n2)-1/n2*j(n2))*ry2;     
  spl = 1/(n1+n2-2)*((n1-1)*s1+(n2-1)*s2);     
  a=inv(spL)*(ry1bar-ry2bar);
  t2= n1*n2/(n1+n2)*(ry1bar-ry2bar)`*a;
print t2;
ustar=t2/(n1+n2-2);
v=(n1+n2-1)*(ustar/(1+ustar));
cv=cinv(.95,4);
pv= 1-probchi(v,4);
print v cv pv;
endsas;
