options ls=72;

data soil;

infile 'table3-8.dat';
input obs group y1 y2 y3 y4;
********************* Part a *****************************************;
PROC IML;
  USE Soil;  
  read all var {y1 y2 y3 y4} into X1 where(group=1);
  read all var {y1 y2 y3 y4} into X2 where(group=2);
  RESET noPRINT;
  N1 = NROW(X1);
  N2 = NROW(X2);
  p=ncol(x);
  x1BAR = 1/N1*X1`*J(N1,1);
  x2BAR = 1/N2*X2`*J(N2,1);
  
  S2 = 1/(N2-1)*X2`*(I(N2)-1/N2*J(N2))*X2;
  S1 = 1/(N1-1)*X1`*(I(N1)-1/N1*J(N1))*X1; 
  Spl = 1/(N1+N2-2)*((N1-1)*S1+(N2-1)*S2);   
left = (x1bar - x2bar)`*inv(spl);
class = .5*(x1bar - x2bar)`*inv(spl)*(x1bar + x2bar);
print 'Linear classification function', left ;
print 'Linear classification rule',class;

********************** part b  *******************************;

firstprt=.5*log(det(s1)/det(s2))-.5*(x1bar`*inv(s1)*x1bar-x2bar`*inv(s2)*x2bar);
secndprt =   x1bar`*inv(s1) - x2bar`*inv(s2);
thirdprt = .5*inv(s1) -.5*inv(s2); 
*** need to find out what is wanted for the quadratic classification funct. *;

print firstprt,secndprt,thirdprt;
print "Q(y) = firstpart + secndprt*y - y*'Thirdprt*y";


********* part a ********** assume p1=p2;
proc discrim data = soil method=normal pool=yes;
class group;
var y1 y2 y3 y4;
title 'Classification Analysis of beetles  data - part a';

************************ Part b ****************************************;

proc discrim data = soil method=normal pool=no;
class group;
var y1 y2 y3 y4;
title 'Quadratic Classification Analysis of beetles data - part b';
run;



