options ls=80 nodate;
data app;
infile 'tab4-10.dat';
input  treat block y1-y6 x1 x2;
if treat =1 or treat=2;
run;
title 'Prob 6.12';
proc iml;
use app;
read all var {y1 y2 y3 y4 y5 y6 } into y;
p=ncol(y);
n=nrow(y);
  y1 = y[1:10,];
  y2 = y[11:21,];
  n1 = nrow(y1);
  n2 = nrow(y2);
v=(n1+n2-2);
  y1BAR = 1/N1*y1`*J(N1,1);
  y2BAR = 1/N2*y2`*J(N2,1);
  S1 = 1/(N1-1)*y1`*(I(N1)-1/N1*J(N1))*y1;     
  S2 = 1/(N2-1)*y2`*(I(N2)-1/N2*J(N2))*y2;     
  Spl = 1/(v)*((N1-1)*S1+(N2-1)*S2);     
  a = INV(Spl)*(y1BAR-y2BAR);
z1=a`*y1bar;
z2=a`*y2bar;
lcf=.5*(z1+z2);
/*lnratio=.5*(log(det(s2)/det(s1)));
qf1= .5*(y1bar`*inv(s1)*y1bar - y2bar`*inv(s2)*y2bar);
qf2=y1bar`*inv(s1) - y2bar`*inv(s2);
qf3=.5*(inv(s1)-inv(s2));*/
d2=(z1-z2);
d2sq=sqrt(d2);
in=-.5*d2sq;
plugin=probnorm(in);
skd2=((n1+n2-p-3)/(v))*d2;
sqsk=sqrt(skd2);
val= -.5*sqsk;
modplug=probnorm(val);


print 'discriminant function';
print a ;
print 'Linear classification function (lcf)';
print    lcf;
print ' Linear classification rule';
print 'Assign y to G1 if a`*y > linear classification function (lcf)';
/*print 'Quadratic classification function ';
print  lnratio qf1 qf2 qf3;
print 'lnratio -qf1+qf2*y -y`*qf3*y ';
print 'y is the vector to be classified';*/
print 'part b';
print 'plug-in error estimate',plugin;

print 'part c';

print 'modified plug-in error estimate',modplug;

print 'part d';
print 'The logistic regression classification rule is assign y to G1 if -lcf + a`*y > 0';
/* The proc discrim calculates the error rate for part a*/
proc discrim data=app short ;
class treat;
var y1-y6;
run;

/*proc discrim data=app 
            short method=normal posterr;
class treat;
var y1-y6;
run;*/
endsas; 
