options ls=80 nodate ;
data long;
infile 'table9-1.dat';
input  y x1-x6;
run;

proc iml;
  use long;
  read all var {y x1 x2 x3 x4 x5 x6 } into x;

  n = nrow(x);
  p = ncol(x);
  v=n-1;
  xbar = 1/n*x`*J(n,1);
  S = 1/(n-1)*x`*(I(n)-1/n*J(n))*x;
  dets = det(s);
ls2=(1/p)*(trace(s));
print 'prob 9.20';
d=diag(s);
ns=s-d;
s2r=(1/(p*(p-1)))*(ns[+,+]);
r=s2r/ls2;
u=det(s)/((ls2##p)*(1-r)##(p-1)*(1+(p-1)*r));
uprime= (-1*(v-(p*(p+1)##2 *(2*p-3))/(6*(p-1)*(p##2 +p-4)))) *(log(u));
cvchi=cinv(.95,.5*p*(p+1)-2);

c1= (p*(p+1)##2 *(2*p-3))/(6*v*(p-1)*(p##2 +p-4)) ;
c2=(p*(p##2 -1)*(p+2))/(6*v##2*(p##2+p-4));
g1=.5*p*(p+1)-2;
g2=(g1+2)/(c2-c1##2);
fapprox=(-1*((g2-g2*c1-g1)*v)/(g1*g2))*log(u);
cvf=finv(.95,g1,g2);
corrma=inv(sqrt(d))*s*inv(sqrt(d));
dr=diag(corrma);
nrma=corrma-dr  ;

rbar=(1/(p*(p-1)))*(nrma[+,+]);
w=1-rbar;
q=((p-1)##2 *(1-w##2))/(p-(p-2)*w##2);
ssum=0;
totsum=0;
rowcnt=1;
do while (rowcnt <=p);
colcnt=1;
do while (colcnt <=p);
if rowcnt < colcnt then
do;
ssum=(corrma(|rowcnt,colcnt|)-rbar);
ssum=ssum##2;
totsum=ssum+totsum;
end;
colcnt=colcnt+1;
end;
rowcnt=rowcnt+1;
end;
vcnt=1;
vrbar=j(p,1);
do while(vcnt<=p);
sumr=sum(corrma[,vcnt])-1;
vrbar(|vcnt|)=(1/(p-1))*sumr;
vcnt=vcnt+1;
end;
vrbar=(vrbar-rbar);
vrbar=q*(vrbar`*vrbar);
u=(v/w##2)*(totsum-vrbar);
cvchi=cinv(.95,.5*(p+1)*(p-2));
print u cvchi;
endsas;

