options ls=78;
data try;
infile 'table7-1.dat';
input y1 y2 y3 x1 x2 x3 x4 x5 x6;
one=1;
run;
proc reg ;
model y1= y2 y3 x1-x6;
run;
proc princomp cov outstat =new out=prcp ;
var   y2 y3 x1 x2 x3 x4 x5 x6;
run;

proc reg data=prcp outest=betas;
model y1 = prin1-prin8;
run;
proc iml;
use new;
read all var{y2 y3 x1 x2 x3 x4 x5 x6} into biga where(_type_='SCORE');
read all var{y2 y3 x1 x2 x3 x4 x5 x6} into e where(_type_='EIGENVAL');
use try;
read all var{y2 y3 x1 x2 x3 x4 x5 x6} into x;
use betas;
/* NOTE the betas outtest file has the coefficients listed under the independent variable names.
Thus, prin# in the nest line
are not the pricipal components that were used in the second proc reg. The prin# in the next line
are beta coefficients*/
read all var{prin1 prin2 prin3 prin4 prin5 prin6 prin7 prin8} into delta;
use try;
read all var {y1} into y;
n=nrow(x);
/* Note that biga is read in with the eigen vectors as the rows instead of columns like in the book.
Thus we use biga transpose to get B1 as the same goes for delta.*/ 
/* This commented out code is just the matrix way of doing what the uncommented code does by
using the output from the above procs */
/*xc=(i(n)-(1/n)*j(n))*x;
b1c=inv(xc`*xc)*xc`*y;
covb1c=inv(xc`*xc);
xcx=xc`*xc;
call eigen(lambda,a,xcx);
z=xc*a;

sxx=xcx/(n-1);
din=inv(diag(lambda));
del1=inv(z`*z)*z`*y;
covdel1=inv(z`*z);
nb1=a*del1;
covnb1=a*din*a`;*/

biga=biga`;
e=e`;
delta=delta`;
Am = biga[,1:3];
eig = e[1:3,];
del2=delta[1:3];
b1=am*del2;
d=inv(diag(eig));
cvb1=am*d*am`;
print del2 ,d;
print b1,cvb1;

totvar=sum(e);
pvl1=e[1,1]/totvar;
pvl2=e[2,1]/totvar;
pvl3=e[3,1]/totvar;
pvl4=e[4,1]/totvar;
pvl5=e[5,1]/totvar;
pvl6=e[6,1]/totvar;
pvl7=e[7,1]/totvar;
pvl8=e[8,1]/totvar;
s2=pvl1+pvl2;
s3=pvl1+pvl2+pvl3;
s4=pvl1+pvl2+pvl3+pvl4;

print totvar pvl1
pvl2
pvl3
pvl4
pvl5
pvl6
pvl7
pvl8 s2 s3 s4;
quit;
endsas;
